/*
<LICENCE>

Copyright (c) 2007, University of Southampton
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

  * Redistributions of source code must retain the above copyright notice, this
	list of conditions and the following disclaimer.

  *	Redistributions in binary form must reproduce the above copyright notice,
	this list of conditions and the following disclaimer in the documentation
	and/or other materials provided with the distribution.

  *	Neither the name of the University of Southampton nor the names of its
	contributors may be used to endorse or promote products derived from this
	software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

</LICENCE>
*/

package r2q2.rendering.xhtml.processors.util;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Random;
import java.util.Vector;

import org.jdom.Element;

public class ListElements {
	
	private static Random r = null;
	
	public static Random getRandom()
	{
		if (r == null)
			r = new Random();
		return r;
	}
	
	public static List<String> getOrder(List<Element> orderedList)
	{
		
		Vector<String> rets = new Vector<String>();
		for(int i=0; i<orderedList.size(); i++)
		{
			rets.add(orderedList.get(i).getAttributeValue("identifier"));
		}
		return rets;
	}
	
	public static List<Element> orderList(List<Element> originalList,List<String> pos)
	{
		List<Element> retList = new Vector<Element>(originalList.size());
		for(int i=0; i<originalList.size(); i++)
			retList.add(originalList.get(i));
		for(int i=0; i < originalList.size(); i++)
		{
			String ident = originalList.get(i).getAttributeValue("identifier");
			//get position from pos
			int index = 0;
			for(int j=0; j<pos.size();j++)
				if(pos.get(j).equals(ident))
					index = j;
			retList.set(index, originalList.get(i));
		}
		return retList;
	}
	
	/*
	 * randomly shuffles the list, preventing movement of fixed values 
	 */
	public static List<Element> randomiseList(List<Element> originalList)
	{
		int size = originalList.size();
		List<Element> rets = new Vector<Element>();
		for(int i=0; i<size; i++)
			rets.add(originalList.get(i));
		
		Element tmp = null;
		for(int i=0; i < size; i++)
		{
			String fixed = rets.get(i).getAttributeValue("fixed");
			if(fixed == null || !Boolean.parseBoolean(fixed))
			{
				//choose a target at random in the range
				int test = getRandom().nextInt(size);
				String isFixed = rets.get(test).getAttributeValue("fixed");
				if(isFixed != null && Boolean.parseBoolean(isFixed))
				{
					while(Boolean.parseBoolean(isFixed))
					{
						++test;
						if(test >= size)
							test = 0;
						isFixed = rets.get(test).getAttributeValue("fixed");
					}
				}
				tmp = rets.get(i);
				rets.set(i, rets.get(test));
				rets.set(test, tmp);
			}
		}
		return rets;
	}
}
