/*
<LICENCE>

Copyright (c) 2007, University of Southampton
All rights reserved.

Redistribution and use in source and binary forms, with or without modification,
are permitted provided that the following conditions are met:

  * Redistributions of source code must retain the above copyright notice, this
	list of conditions and the following disclaimer.

  *	Redistributions in binary form must reproduce the above copyright notice,
	this list of conditions and the following disclaimer in the documentation
	and/or other materials provided with the distribution.

  *	Neither the name of the University of Southampton nor the names of its
	contributors may be used to endorse or promote products derived from this
	software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

</LICENCE>
*/

package r2q2.variable;

import java.util.HashMap;
import java.util.Vector;

public class OutcomeDeclaraton extends ItemVariable {
	public String interpretation = null; //string
	public String longInterpretation = null; //string
	public Double normalMaximum = null; //float
	public Double normalMinimum = null; //float
	public Double masteryValue = null; //float
	
	public Object getDefaultValue() {
		return this.defaultValue;
	}
	
	public HashMap<String,Object> toLegacyFormat()
	{
		HashMap<String,Object> retMap = super.toLegacyFormat();
		
		retMap.put("identifier", this.identifier);
		
		if(this.value != null)
		{
			Vector<String> strForm = new Vector<String>();
			if(this.value instanceof Vector)
			{
				for(int i=0; i < ((Vector)value).size(); i++)
					if(((Vector)value).elementAt(i) != null)
						strForm.add(((Vector)value).elementAt(i).toString());
			}
			else
				strForm.add(value.toString());
			retMap.put(this.identifier, strForm);
		}
		
		if(interpretation != null)
			retMap.put("interpretation", interpretation);
		if(longInterpretation != null)
			retMap.put("longInterpretation", longInterpretation);
		if(normalMaximum != null)
			retMap.put("normalMaximum", normalMaximum.toString());
		//TODO re-enable this line when initialisation engine is fixed
		/*if(longInterpretation != null)
			retMap.put("normalMinimum", normalMaximum.toString());*/
		if(longInterpretation != null)
			retMap.put("masterValue", masteryValue.toString());
		return retMap;
	}
}
